Subject: Re: [PATCH] drivers/net: remove network drivers' last few uses of IRQF_SAMPLE_RANDOM

From: Pavel Machek <[email-masked]>
Date: Fri, 30 May 2008 21:50:52 +0200

Hi!

> >  Just a shot in the dark... would hw sensors (raw data) chips be a good source
> >  of entropy for /dev/random ?? 
> 
> For systems with high resolution timers, even if an attacker has total
> knowledge/control of the network, it doesn't seem realistically possible
> for them to determine the low order bits of the nanosecond timer of
> disk and network I/O system calls, if those were used as a source of
> entropy.  I think this is a case of the (unrealistic) best being an
> enemy of the common (and realistic) good.
> 
> Another idea that occured to me:  How about using the low order bits
> of the instruction memory address being executed that was interrupted
> by the HZ timer interrupt.  This also doesn't seem to be something
> that an external attacker could realistically determine.  And a
> combination of these approaches would be that much stronger, combined
> of course with any other available entropy sources.

Well, I'd fear that hlt instruction in idle loop would be the one
interrupted most. But low bits of tsc at timer interrupt would be fine
entropy source.

..actually, bogomips varies a bit between boots, maybe we should hash
it into the pool?

Maybe we could even redo bogomips calculation at runtime and use low
bits as random numbers? :-).
							Pavel
-- 
(english) http://www.livejournal.com/~pavelmachek
(cesky, pictures) http://atrey.karlin.mff.cuni.cz/~pavel/picture/horses/blog.html